/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.chukwa.rest.objects;

// Generated May 28, 2009 3:39:53 PM by Hibernate Tools 3.2.4.GA

import java.sql.Timestamp;

/**
 * MrTask generated by hbm2java
 */
public class MrTask implements java.io.Serializable {
    static final long serialVersionUID = -3576396954756842562L;

    private String taskId;
    private String jobId;
    private Timestamp startTime;
    private Timestamp finishTime;
    private String status;
    private Byte attempts;
    private Long hdfsBytesRead;
    private Long hdfsBytesWritten;
    private Long localBytesRead;
    private Long localBytesWritten;
    private Long mapInputBytes;
    private Long mapOutputBytes;
    private Long mapInputRecords;
    private Long mapOutputRecords;
    private Long combineInputRecords;
    private Long combineOutputRecords;
    private Long spilledRecords;
    private Long reduceInputGroups;
    private Long reduceOutputGroups;
    private Long reduceInputRecords;
    private Long reduceOutputRecords;
    private Long reduceInputBytes;
    private Long reduceOutputBytes;
    private String type;
    private Long reduceShuffleBytes;
    private String hostname;
    private Timestamp shuffleFinished;
    private Timestamp sortFinished;
    private Long spilts;

    public MrTask() {
    }

    public MrTask(String taskId, Timestamp startTime, Timestamp finishTime,
		  Timestamp shuffleFinished, Timestamp sortFinished) {
	this.taskId = taskId;
	this.startTime = startTime;
	this.finishTime = finishTime;
	this.shuffleFinished = shuffleFinished;
	this.sortFinished = sortFinished;
    }

    public MrTask(String taskId, String jobId, Timestamp startTime,
		  Timestamp finishTime, String status, Byte attempts, Long hdfsBytesRead,
		  Long hdfsBytesWritten, Long localBytesRead, Long localBytesWritten,
		  Long mapInputBytes, Long mapOutputBytes, Long mapInputRecords,
		  Long mapOutputRecords, Long combineInputRecords,
		  Long combineOutputRecords, Long spilledRecords,
		  Long reduceInputGroups, Long reduceOutputGroups,
		  Long reduceInputRecords, Long reduceOutputRecords,
		  Long reduceInputBytes, Long reduceOutputBytes, String type,
		  Long reduceShuffleBytes, String hostname, Timestamp shuffleFinished,
		  Timestamp sortFinished, Long spilts) {
	this.taskId = taskId;
	this.jobId = jobId;
	this.startTime = startTime;
	this.finishTime = finishTime;
	this.status = status;
	this.attempts = attempts;
	this.hdfsBytesRead = hdfsBytesRead;
	this.hdfsBytesWritten = hdfsBytesWritten;
	this.localBytesRead = localBytesRead;
	this.localBytesWritten = localBytesWritten;
	this.mapInputBytes = mapInputBytes;
	this.mapOutputBytes = mapOutputBytes;
	this.mapInputRecords = mapInputRecords;
	this.mapOutputRecords = mapOutputRecords;
	this.combineInputRecords = combineInputRecords;
	this.combineOutputRecords = combineOutputRecords;
	this.spilledRecords = spilledRecords;
	this.reduceInputGroups = reduceInputGroups;
	this.reduceOutputGroups = reduceOutputGroups;
	this.reduceInputRecords = reduceInputRecords;
	this.reduceOutputRecords = reduceOutputRecords;
	this.reduceInputBytes = reduceInputBytes;
	this.reduceOutputBytes = reduceOutputBytes;
	this.type = type;
	this.reduceShuffleBytes = reduceShuffleBytes;
	this.hostname = hostname;
	this.shuffleFinished = shuffleFinished;
	this.sortFinished = sortFinished;
	this.spilts = spilts;
    }

    public String getTaskId() {
	return this.taskId;
    }

    public void setTaskId(String taskId) {
	this.taskId = taskId;
    }

    public String getJobId() {
	return this.jobId;
    }

    public void setJobId(String jobId) {
	this.jobId = jobId;
    }

    public Timestamp getStartTime() {
	return this.startTime;
    }

    public void setStartTime(Timestamp startTime) {
	this.startTime = startTime;
    }

    public Timestamp getFinishTime() {
	return this.finishTime;
    }

    public void setFinishTime(Timestamp finishTime) {
	this.finishTime = finishTime;
    }

    public String getStatus() {
	return this.status;
    }

    public void setStatus(String status) {
	this.status = status;
    }

    public Byte getAttempts() {
	return this.attempts;
    }

    public void setAttempts(Byte attempts) {
	this.attempts = attempts;
    }

    public Long getHdfsBytesRead() {
	return this.hdfsBytesRead;
    }

    public void setHdfsBytesRead(Long hdfsBytesRead) {
	this.hdfsBytesRead = hdfsBytesRead;
    }

    public Long getHdfsBytesWritten() {
	return this.hdfsBytesWritten;
    }

    public void setHdfsBytesWritten(Long hdfsBytesWritten) {
	this.hdfsBytesWritten = hdfsBytesWritten;
    }

    public Long getLocalBytesRead() {
	return this.localBytesRead;
    }

    public void setLocalBytesRead(Long localBytesRead) {
	this.localBytesRead = localBytesRead;
    }

    public Long getLocalBytesWritten() {
	return this.localBytesWritten;
    }

    public void setLocalBytesWritten(Long localBytesWritten) {
	this.localBytesWritten = localBytesWritten;
    }

    public Long getMapInputBytes() {
	return this.mapInputBytes;
    }

    public void setMapInputBytes(Long mapInputBytes) {
	this.mapInputBytes = mapInputBytes;
    }

    public Long getMapOutputBytes() {
	return this.mapOutputBytes;
    }

    public void setMapOutputBytes(Long mapOutputBytes) {
	this.mapOutputBytes = mapOutputBytes;
    }

    public Long getMapInputRecords() {
	return this.mapInputRecords;
    }

    public void setMapInputRecords(Long mapInputRecords) {
	this.mapInputRecords = mapInputRecords;
    }

    public Long getMapOutputRecords() {
	return this.mapOutputRecords;
    }

    public void setMapOutputRecords(Long mapOutputRecords) {
	this.mapOutputRecords = mapOutputRecords;
    }

    public Long getCombineInputRecords() {
	return this.combineInputRecords;
    }

    public void setCombineInputRecords(Long combineInputRecords) {
	this.combineInputRecords = combineInputRecords;
    }

    public Long getCombineOutputRecords() {
	return this.combineOutputRecords;
    }

    public void setCombineOutputRecords(Long combineOutputRecords) {
	this.combineOutputRecords = combineOutputRecords;
    }

    public Long getSpilledRecords() {
	return this.spilledRecords;
    }

    public void setSpilledRecords(Long spilledRecords) {
	this.spilledRecords = spilledRecords;
    }

    public Long getReduceInputGroups() {
	return this.reduceInputGroups;
    }

    public void setReduceInputGroups(Long reduceInputGroups) {
	this.reduceInputGroups = reduceInputGroups;
    }

    public Long getReduceOutputGroups() {
	return this.reduceOutputGroups;
    }

    public void setReduceOutputGroups(Long reduceOutputGroups) {
	this.reduceOutputGroups = reduceOutputGroups;
    }

    public Long getReduceInputRecords() {
	return this.reduceInputRecords;
    }

    public void setReduceInputRecords(Long reduceInputRecords) {
	this.reduceInputRecords = reduceInputRecords;
    }

    public Long getReduceOutputRecords() {
	return this.reduceOutputRecords;
    }

    public void setReduceOutputRecords(Long reduceOutputRecords) {
	this.reduceOutputRecords = reduceOutputRecords;
    }

    public Long getReduceInputBytes() {
	return this.reduceInputBytes;
    }

    public void setReduceInputBytes(Long reduceInputBytes) {
	this.reduceInputBytes = reduceInputBytes;
    }

    public Long getReduceOutputBytes() {
	return this.reduceOutputBytes;
    }

    public void setReduceOutputBytes(Long reduceOutputBytes) {
	this.reduceOutputBytes = reduceOutputBytes;
    }

    public String getType() {
	return this.type;
    }

    public void setType(String type) {
	this.type = type;
    }

    public Long getReduceShuffleBytes() {
	return this.reduceShuffleBytes;
    }

    public void setReduceShuffleBytes(Long reduceShuffleBytes) {
	this.reduceShuffleBytes = reduceShuffleBytes;
    }

    public String getHostname() {
	return this.hostname;
    }

    public void setHostname(String hostname) {
	this.hostname = hostname;
    }

    public Timestamp getShuffleFinished() {
	return this.shuffleFinished;
    }

    public void setShuffleFinished(Timestamp shuffleFinished) {
	this.shuffleFinished = shuffleFinished;
    }

    public Timestamp getSortFinished() {
	return this.sortFinished;
    }

    public void setSortFinished(Timestamp sortFinished) {
	this.sortFinished = sortFinished;
    }

    public Long getSpilts() {
	return this.spilts;
    }

    public void setSpilts(Long spilts) {
	this.spilts = spilts;
    }

}
